%define	name			mesa
%define version			6.5
%define release			%mkrel 18
%define priority		500

%define eglname			mesaegl
%define glname			mesagl
%define gluname			mesaglu
%define glutname		mesaglut
%define glwname			mesaglw
%define eglmajor		1
%define glmajor			1
%define glumajor		1
%define glutmajor		3
%define glwmajor		1
%define libeglname              %mklibname %{eglname} %{eglmajor}
%define libglname		%mklibname %{glname} %{glmajor}
%define libgluname		%mklibname %{gluname} %{glumajor}
%define libglutname		%mklibname %{glutname} %{glutmajor}
%define libglwname		%mklibname %{glwname} %{glwmajor}

%define oldlibglname		%mklibname MesaGL 1
%define oldlibgluname		%mklibname MesaGLU 1
%define oldlibglutname		%mklibname Mesaglut 3

%define mesasrcdir		%{_prefix}/src/Mesa/
%define driver_dir		%{_libdir}/dri

%define enable_egl		0

#FIXME: (for 386/485) unset SSE, MMX and 3dnow flags
#FIXME: (for >=i586)  disable sse
#       SSE seems to have problem on some apps (gtulpas) for probing.
%define	dri_drivers_i386	"i810 i915 i965 mga mach64 r128 r200 r300 radeon savage sis unichrome tdfx"

%define	dri_drivers_x86_64	"mach64 i810 i915 i965 mga mach64 r128 r200 r300 radeon savage sis unichrome tdfx"
%define	dri_drivers_ppc		"mach64 r128 r200 r300 radeon tdfx"
%define	dri_drivers_ia64	"i810 i915 i965 mga r128 r200 radeon"
%define	dri_drivers_alpha	"mga r128 r200 radeon"
%define	dri_drivers_sparc	"ffb mach64 mga radeon savage"
%define	dri_drivers		%{expand:%{dri_drivers_%{_arch}}}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	OpenGL 1.4 compatible 3D graphics library
Group:		System/Libraries
BuildRequires:	tcl
BuildRequires:	texinfo
BuildRequires:	makedepend
BuildRequires:	libexpat-devel
BuildRequires:	x11-proto-devel >= 1.0.0
BuildRequires:	libx11-devel >= 1.0.0
BuildRequires:	libdrm-devel >= 2.0.1
BuildRequires:	libxext-devel >= 1.0.0
BuildRequires:	libxxf86vm-devel >= 1.0.0
BuildRequires:	libxmu-devel >= 1.0.0
BuildRequires:	libxi-devel >= 1.0.0
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
URL:		http://www.mesa3d.org
Source0:	http://prdownloads.sourceforge.net/mesa3d/MesaLib-%{version}.tar.bz2
Source1:	http://prdownloads.sourceforge.net/mesa3d/MesaDemos-%{version}.tar.bz2
Source2:	http://prdownloads.sourceforge.net/mesa3d/MesaGLUT-%{version}.tar.bz2
Source3:	mesa-source-file-generator
Source4:	Mesa-icons.tar.bz2
Source5:	mesa-driver-install

# i965 DRI support - taken from Mesa CVS 20060901
Source6: mesa-dri-i965-20060901.tar.bz2

# patch from the fedora mesa package to enable installing in a different prefix
Patch1:		mesa-6.4-multilib-fix.patch
# DRI modules are not under /usr/X11R6 anymore
Patch2:		mesa-6.5-default_dri_dir.patch
# Install EGL header files and fixes other minor compilations problems when enabling EGL
Patch3:		mesa-egl_support.patch
# Enable r300 support (it is experimental yet)
Patch5:		mesa-6.5-force-r300.patch
# static inline functions are broken on some architetures
Patch6:		mesa-6.5-drop-static-inline.patch
# In some cases radeon may have 0 bits depth
Patch7:		mesa-radeon-0depthbits.patch
# No exec stack for ELF
Patch8:		mesa-6.5-noexecstack.patch
# Fix compilation on x86_64 
Patch9:		mesa-6.5-x86_64-fix-build.patch
# Disable compilation of broken demos
Patch10:	mesa-6.5-xdemos_remove_broken.patch
# Fixes for the texture_from_pixmap
Patch11:	mesa-6.5-tfp-fbconfig-attribs.patch
Patch12:	mesa-6.5-fix-pbuffer-dispatch.patch
# Fix linux-dri so it can be used for all archs (thanks Christiaan Welvaart)
Patch13:	Mesa-6.5-linux-dri-config.patch
# Disable some checks making Google Earth work on r300
Patch14:	mesa-6.5-google_earth_support.patch

# Fix compilation of the i965 driver on mesa 6.5
# This patch requires the source of i965 to be present
Patch15:	Mesa-6.5-i965_compile_fix.patch

# More i965 fixes
Patch16:        965_changes.patch
Patch17:        mesa-add_format_z16.patch
Patch18:        mesa-export_mesa_print_alu_instruction.patch
# "google earth fix"
Patch19:        mesa-normal_varray.patch
# glxinfo segfault
Patch20:        mesa-drawbuffer_check.patch
# Missing support for aiglx
Patch21:        mesa-add_state_texrect_scale.patch
Patch22:        mesa-arb_texture_rectangle.patch
# strict aliasing fix
Patch23:	mesa-strict_aliasing_fix.patch


# Add attrib_list to glXBindTexImageEXT
Patch40:	mesa-6.5-teximage-attrib-list.patch
# Update function signatures for EXT_tfp entrypoints.
Patch41:	mesa-6.5-tfp_entrypoints.patch
# Update GLX_EXT_texture_from_pixmap tokens
Patch42:	mesa-6.5-texture_from_pixmap_tokens.patch
# remove unfinished GLX_ARB_render_texture
Patch43:	mesa-6.5-no-ARB_render_texture.patch
# (blino) https://bugs.freedesktop.org/show_bug.cgi?id=6241
# cvs diff -b -r 1.59 -r 1.60 src/mesa/drivers/dri/radeon/radeon_screen.c
# use gart base from drm not try to work it out ourselves.. bump radeon client
# to need 1.6 drm where this first appeared.. this fixes r300 on PCIE
Patch44:	mesa-6.5-fix-r300-PCIE.patch
# (blino) cumulative patch of revisions 1.50, 1.51, 1.52 and 1.55
#         from src/mesa/drivers/dri/r300/r300_context.c (freedesktop CVS)
# Ensure all GART allocations are freed on context destruction, rather than
# waiting for the DRM to reap them at process exit.  Fixes (fatal) allocation
# failures in AIGLX configurations.
Patch45:	mesa-6.5-r300-free-gart-mem.patch
Patch46:	mesa-6.5-ctx.patch

License:	MIT
Requires:	%{libglname} = %{version}-%{release}
Provides:	hackMesa = %{version}
Obsoletes:	hackMesa <= %{version}
Provides:	Mesa = %{version}
Obsoletes:	Mesa < %{version}

%package	source
Summary:	Source files required for the Xorg 7.0 to enable glx support
Group:		Development/C
Requires:	%{libglname}-devel >= %{version}

%if %{enable_egl}
%package -n	%{libeglname}
Summary:	Files for Mesa (EGL libs)
Group:		System/Libraries

%package -n	%{libeglname}-devel
Summary:	Development files for Mesa (EGL libs)
Group:		Development/C
Requires:	%{name} = %{version}
Provides:	EGL-devel
%endif

%package -n	%{libglname}
Summary:	Files for Mesa (GL and GLX libs)
Group:		System/Libraries
Obsoletes:	%{oldlibglname} < 6.4 
Provides:	%{oldlibglname} = %{version}-%{release}

%package -n	%{libglname}-devel
Summary:	Development files for Mesa (OpenGL compatible 3D lib)
Group:		Development/C
Requires:	%{name} = %{version}
Provides:	lib%{glname}-devel = %{version}-%{release}
Provides:	%{glname}-devel = %{version}-%{release}
Provides:	GL-devel
Obsoletes:	%{oldlibglname}-devel < 6.4
Provides:	%{oldlibglname}-devel = %{version}-%{release}
Provides:	libMesaGL-devel = %{version}-%{release}
Provides:	MesaGL-devel = %{version}-%{release}

%package -n	%{libgluname}
Summary:	Files for Mesa (GLU libs)
Group:		System/Libraries
Obsoletes:	%{oldlibgluname} < 6.4
Provides:	%{oldlibgluname} = %{version}-%{release}

%package -n	%{libgluname}-devel
Summary:	Development files for GLU libs
Group:		Development/C
Requires:	%{libgluname} = %{version}-%{release}
Provides:	lib%{gluname}-devel = %{version}-%{release}
Provides:	%{gluname}-devel = %{version}-%{release}
Obsoletes:	%{oldlibgluname}-devel < 6.4
Provides:	%{oldlibgluname}-devel = %{version}-%{release}
Provides:	libMesaGLU-devel = %{version}-%{release}
Provides:	MesaGLU-devel = %{version}-%{release} 

%package -n	%{libglutname}
Summary:	Files for Mesa (glut libs)
Group:		System/Libraries
Requires:	%{libgluname} = %{version}-%{release}
Provides:	Mesa-common = %{version}-%{release} hackMesa-common = %{version}
Obsoletes:	Mesa-common <= %{version} hackMesa-common <= %{version}
Obsoletes:	%{oldlibglutname} < 6.4
Provides:	%{oldlibglutname} = %{version}-%{release}

%package -n	%{libglutname}-devel
Summary:	Development files for glut libs
Group:		Development/C
Requires:	%{libglutname} = %{version}-%{release} %{libgluname}-devel = %{version}-%{release}
Provides:	lib%{glutname}-devel = %{version}-%{release} 
Provides:	%{glutname}-devel = %{version}-%{release} 
Obsoletes:	%{oldlibglutname}-devel < 6.4
Provides:	%{oldlibglutname}-devel = %{version}-%{release}
Provides:	libMesaGLUT-devel = %{version}-%{release}
Provides:	MesaGLUT-devel = %{version}-%{release}

%package -n	%{libglwname}
Summary:	Files for Mesa (glw libs)
Group:		System/Libraries
Provides:	Mesa-common = %{version}-%{release} hackMesa-common = %{version}
Obsoletes:	Mesa-common <= %{version} hackMesa-common <= %{version}

%package -n	%{libglwname}-devel
Summary:	Development files for glw libs
Group:		Development/C
Requires:	%{libglwname} = %{version}-%{release}
Provides:	lib%{glwname}-devel = %{version}-%{release} 
Provides:	%{glwname}-devel = %{version}-%{release} 

%package	common-devel
Summary:	Meta package for mesa devel
Group:		Development/C
Provides:	Mesa-common-devel = %{version}-%{release} 
Provides:	hackMesa-common-devel = %{version}
Obsoletes:	Mesa-common-devel < %{version} 
Obsoletes:	hackMesa-common-devel < %{version}
Requires:	%{libglname}-devel = %{version}
Requires:	%{libglwname}-devel = %{version}
Requires:	%{libgluname}-devel = %{version}
Requires:	%{libglutname}-devel = %{version}

%package	demos
Summary:	Demos for Mesa (OpenGL compatible 3D lib)
Group:		Graphics
Requires:	%{name} >= %{version}
Provides:	hackMesa-demos = %{version}
Obsoletes:	hackMesa-demos <= %{version}
Obsoletes: 	Mesa-demos < 6.4
Provides:	Mesa-demos = %{version}-%{release}

%description
Mesa is an OpenGL 1.4 compatible 3D graphics library.

%description	source
Mesa is an OpenGL 1.4 compatible 3D graphics library.

Source files required by the Xorg to enable glx support.

%description common-devel
Mesa common metapackage devel

%if %{enable_egl}
%description -n	%{libeglname}
Mesa is an OpenGL 1.4 compatible 3D graphics library.
EGL parts.

%description -n	%{libeglname}-devel
Mesa is an OpenGL 1.4 compatible 3D graphics library.
EGL development parts.
%endif

%description -n	%{libglname}
Mesa is an OpenGL 1.4 compatible 3D graphics library.
GL and GLX parts.

%description -n	%{libglname}-devel
Mesa is an OpenGL 1.4 compatible 3D graphics library.

This package contains the headers needed to compile Mesa programs.

%description -n	%{libgluname}
GLU is the OpenGL Utility Library.
It provides a number of functions upon the base OpenGL library to provide
higher-level drawing routines from the more primitive routines provided by
OpenGL.

%description -n	%{libgluname}-devel
This package contains the headers needed to compile programs with GLU.

%description -n	%{libglutname}
GLUT (OpenGL Utility Toolkit) is a addon library for OpenGL programs. It
provides them utilities to define and control windows, input from the keyboard
and the mouse, drawing some geometric primitives (cubes, spheres, ...).
GLUT can even create pop-up windows.

%description -n	%{libglutname}-devel
Mesa is an OpenGL 1.4 compatible 3D graphics library.
glut parts.

This package contains the headers needed to compile Mesa programs.

%description -n	%{libglwname}
GLw adds Motif bindings to the OpenGL "canvas" (Xt/Motif/OpenGL widget code).

%description -n	%{libglwname}-devel
Mesa is an OpenGL 1.4 compatible 3D graphics library.
GLw parts.

This package contains the headers needed to compile Mesa programs.

%description	demos
Mesa is an OpenGL 1.4 compatible 3D graphics library.

This package contains some demo programs for the Mesa library.

%prep
%setup -q -n Mesa-%{version} -b1 -b2

%patch1 -p0 -b .multilib
%patch2 -p1 -b .default_dri_dir

%if %{enable_egl}
%patch3 -p1 -b .egl_support
%endif

%patch40 -p0 -b .attrib
%patch41 -p0 -b .tfp_entrypoints
%patch42 -p0 -b .pixmap_tokens
%patch43 -p0 -b .no-ARB_render_texture
%patch44 -p0 -b .r300_PCIE
%patch45 -p0 -b .r300_free_gart
%patch46 -p1 -b .ctx
%patch5 -p0 -b .force_r300
%patch6 -p0 -b .static_inline
%patch7 -p0 -b .0depth
%patch8 -p0 -b .noexecstack
%if "%{_lib}" != "lib"
%patch9 -p0 -b .staticinline
%endif
%patch10 -p1 -b .removebroken
%patch11 -p0 -b .fbconfig_attr
%patch12 -p0 -b .pbuffer_dispatch
%patch13 -p1 -b .linux-dri-config
%patch14 -p1 -b .google_earth_r300

# unpack i965 DRI
pushd src/mesa/drivers/dri
tar jxf %{SOURCE6}
popd
# patch it to compile against mesa 6.5
%patch15 -p1 -b .i965

%patch16 -p2 -b 965_changes
%patch17 -p1 -b .z16
%patch18 -p1 -b .alu
%patch19 -p1 -b .normal
%patch20 -p1 -b .drawbuffer
%patch21 -p1 -b .texrect
%patch22 -p1 -b .rect
%patch23 -p1 -b .aliasing


pushd progs/demos && {
	for i in *.c; do 
	perl -pi -e "s|\.\./images/|%{_libdir}/mesa-demos-data/|" $i ; 
	done 
	perl -pi -e "s|isosurf.dat|%{_libdir}/mesa-demos-data/isosurf.dat|" isosurf.c 
} && popd
pushd progs/xdemos && {
	for i in *.c; do 
	perl -pi -e "s|\.\./images/|%{_libdir}/mesa-demos-data/|" $i ; 
	done 
	perl -pi -e "s|isosurf.dat|%{_libdir}/mesa-demos-data/isosurf.dat|" isosurf.c 
} && popd

chmod +x %{SOURCE3} %{SOURCE5}

%build
LIB_DIR=$RPM_BUILD_ROOT%{_libdir}
INCLUDE_DIR=$RPM_BUILD_ROOT%{_includedir}
DRI_DRIVER_DIR="%{driver_dir}"
export LIB_DIR INCLUDE_DIR DRI_DRIVER_DIR

ARCH_FLAGS="$RPM_OPT_FLAGS -DNDEBUG -DDEFAULT_DRIVER_DIR=\\\"%{driver_dir}\\\""
export ARCH_FLAGS

# (tv) parallel build is broken:
make MKDEP=/usr/bin/makedepend USING_EGL=%{enable_egl} DRI_DIRS=%{dri_drivers} linux-dri

pushd progs/demos
%make
popd
pushd progs/xdemos
%make
popd

%install
LIB_DIR=$RPM_BUILD_ROOT%{_libdir}
INCLUDE_DIR=$RPM_BUILD_ROOT%{_includedir}
DRI_DRIVER_DIR="%{_libdir}/dri"
export LIB_DIR INCLUDE_DIR DRI_DRIVER_DIR DRIMODULE_SRCDIR DRIMODULE_DESTDIR

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mesa-demos-data
mkdir -p $RPM_BUILD_ROOT%{_includedir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
make DESTDIR=$RPM_BUILD_ROOT MKDEP=/usr/bin/makedepend USING_EGL=%{enable_egl} install

mkdir -p $RPM_BUILD_ROOT%{_bindir}
for i in bounce clearspd drawpix gamma gears glinfo glutfx isosurf morph3d \
         multiarb paltex pointblast reflect renormal \
         spectex stex3d tessdemo texcyl texobj trispd winpos; do
  cp -v progs/demos/$i $RPM_BUILD_ROOT%{_bindir}
done

for i in glthreads glxdemo glxgears glxgears_fbconfig glxcontexts glxheads \
        glxinfo glxpixmap glxpbdemo glxswapcontrol manywin offset overlay \
        pbinfo pbdemo wincopy xfont xrotfontdemo yuvrect_client; do
  cp -v progs/xdemos/$i $RPM_BUILD_ROOT%{_bindir} 
done

# (fg) So that demos at least work :)
cp -v progs/images/*rgb progs/demos/isosurf.dat $RPM_BUILD_ROOT%{_libdir}/mesa-demos-data

# (blino) hardlink libGL files in %{_libdir}/mesa
# to prevent proprietary driver installers from removing them
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mesa
pushd $RPM_BUILD_ROOT%{_libdir}/mesa
for l in ../libGL.so.*; do cp -a $l .; done
popd

# (gb) use update-alternatives to manage several GL libraries/drivers
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/GL/
cat > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/GL/%{libglname}.conf << EOF
# This file is knowingly empty since %{_libdir} is a standard search path
EOF
touch $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/GL.conf

# install dri modules
DRIMODULE_SRCDIR="lib"
DRIMODULE_DESTDIR="$RPM_BUILD_ROOT$DRI_DRIVER_DIR"
export DRIMODULE_SRCDIR DRIMODULE_DESTDIR
DRI_DRIVERS=%{dri_drivers} %{SOURCE5}

# icons for three demos examples [we lack a frontend
# to launch the demos obviously]
install -m 755 -d $RPM_BUILD_ROOT%{_miconsdir}
install -m 755 -d $RPM_BUILD_ROOT%{_iconsdir}
install -m 755 -d $RPM_BUILD_ROOT%{_liconsdir}
tar jxvf %{SOURCE4} -C $RPM_BUILD_ROOT%{_iconsdir}

# clean any .la file with still reference to tmppath.
perl -pi -e "s|\S+$RPM_BUILD_DIR\S*||g" $RPM_BUILD_ROOT/%{_libdir}/*.la

# generate mesa source files
%{SOURCE3} $RPM_BUILD_ROOT %{mesasrcdir}


%clean
rm -fr $RPM_BUILD_ROOT

%if %{enable_egl}
%post -n %{libeglname} -p /sbin/ldconfig
%postun -n %{libeglname} -p /sbin/ldconfig
%endif

%post -n %{libglname}
/usr/sbin/update-alternatives --install %{_sysconfdir}/ld.so.conf.d/GL.conf gl_conf %{_sysconfdir}/ld.so.conf.d/GL/%{libglname}.conf %{priority}
if [ ! -L %{_sysconfdir}/ld.so.conf.d/GL.conf ]; then
  /usr/sbin/update-alternatives --auto gl_conf
fi
/sbin/ldconfig

%postun -n %{libglname}
if [ ! -f %{_sysconfdir}/ld.so.conf.d/GL/%{libglname}.conf ]; then
  /usr/sbin/update-alternatives --remove gl_conf %{_sysconfdir}/ld.so.conf.d/GL/%{libglname}.conf
fi
/sbin/ldconfig

%post -n %{libgluname} -p /sbin/ldconfig 

%postun -n %{libgluname} -p /sbin/ldconfig

%post -n %{libglutname} -p /sbin/ldconfig 

%postun -n %{libglutname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc docs/COPYING docs/README.*
%doc docs/RELNOTES-3* docs/RELNOTES-4.* docs/VERSIONS

%files source -f mesa-source-rpm-filelist.lst
%defattr(-,root,root)
%doc docs/README.X11 docs/COPYING

%if %{enable_egl}
%files -n %{libeglname}
%defattr(-,root,root)
%{_libdir}/libegl.so.1*
%{_libdir}/libegldri.so.1*

%files -n %{libeglname}-devel
%defattr(-,root,root)
%{_libdir}/libegl.so
%{_libdir}/libegldri.so
%{_includedir}/gles/egl*.h
%endif

%files -n %{libglname}
%defattr(-,root,root)
%dir %{_libdir}/dri
%doc docs/README.X11 docs/COPYING
%ghost %{_sysconfdir}/ld.so.conf.d/GL.conf
%config %{_sysconfdir}/ld.so.conf.d/GL/%{libglname}.conf
%{_libdir}/libGL.so.*
%dir %{_libdir}/mesa
%{_libdir}/mesa/libGL.so.*
%{_libdir}/dri/*
%ifarch %{ix86}
#%{_libdir}/modules/*
%endif

%files -n %{libglname}-devel
%defattr(-,root,root)
%doc docs/README.X11 docs/COPYING
%{_includedir}/GL/gl.h
%{_includedir}/GL/glext.h
%{_includedir}/GL/gl_mangle.h
%{_includedir}/GL/osmesa.h
%ifarch %{ix86} x86_64 ppc %{sunsparc}
%{_includedir}/GL/svgamesa.h
%endif
%{_includedir}/GL/glx.h
%{_includedir}/GL/glxext.h
%{_includedir}/GL/glx_mangle.h
%{_includedir}/GL/xmesa.h
%{_includedir}/GL/xmesa_x.h
%{_includedir}/GL/xmesa_xf86.h
%{_libdir}/libGL.so

#FIXME: check those headers
%{_includedir}/GL/mglmesa.h
%{_includedir}/GL/amesa.h
%{_includedir}/GL/directfbgl.h
%{_includedir}/GL/dmesa.h
%{_includedir}/GL/fxmesa.h
%{_includedir}/GL/ggimesa.h
%{_includedir}/GL/glfbdev.h
%{_includedir}/GL/uglglutshapes.h
%{_includedir}/GL/uglmesa.h
%{_includedir}/GL/vms_x_fix.h
%{_includedir}/GL/wmesa.h

%files -n %{libgluname}
%defattr(-,root,root)
%doc docs/README.X11 docs/COPYING
%{_libdir}/libGLU.so.*

%files -n %{libglutname}
%defattr(-,root,root)
%doc docs/README.X11 docs/COPYING
%{_libdir}/libglut.so.*

%files -n %{libglwname}
%defattr(-,root,root)
%doc docs/README.X11 docs/COPYING
%{_libdir}/libGLw.so.*


%files -n %{libgluname}-devel
%defattr(-,root,root)
%doc docs/README.X11 docs/COPYING
%{_includedir}/GL/glu.h
%{_includedir}/GL/glu_mangle.h
%{_includedir}/GL/mesa_wgl.h
%{_libdir}/libGLU.so

%files -n %{libglutname}-devel
%defattr(-,root,root)
%doc docs/README.X11 docs/COPYING
%{_includedir}/GL/glut.h
%{_includedir}/GL/glutf90.h
%{_libdir}/libglut.so

%files common-devel
%defattr(-,root,root)

%files -n %{libglwname}-devel
%defattr(-,root,root)
%doc docs/README.X11 docs/COPYING
%{_includedir}/GL/GLwDrawA.h
%{_includedir}/GL/GLwDrawAP.h
%{_includedir}/GL/GLwMDrawA.h
%{_includedir}/GL/GLwMDrawAP.h
%{_libdir}/libGLw.so

%files demos
%defattr(-,root,root)
%doc docs/README.X11 docs/COPYING
%{_bindir}/*
%dir %{_libdir}/mesa-demos-data
%{_libdir}/mesa-demos-data/*
%{_miconsdir}/*demos*.png
%{_iconsdir}/*demos*.png
%{_liconsdir}/*demos*.png



%changelog
* Fri Dec 08 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5-18mdv2007.0
+ Revision: 93704
- Add some patches improving the support for Intel 965G cards (#26082)
- Fix a possible aliasing problem in 965G driver source code

* Sat Sep 16 2006 Olivier Blin <oblin@mandriva.com> 6.5-17mdv2007.0
+ Revision: 61745
- fix crash with null context (#25555)

  + Gwenole Beauchesne <gbeauchesne@mandriva.com>
    - use update-alternatives

* Tue Sep 12 2006 Olivier Blin <oblin@mandriva.com> 6.5-15mdv2007.0
+ Revision: 60951
- copy libGL files in _libdir/mesa instead of hardlink them (anyway, the stripping broke the hardlink), or else a rpm weirdness prevents libGL.so.1 from being there (#25553)

* Thu Sep 07 2006 Olivier Blin <oblin@mandriva.com> 6.5-14mdv2007.0
+ Revision: 60557
- hardlink libGL files in _libdir/mesa to prevent proprietary driver installers from removing them

* Mon Sep 04 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5-13mdv2007.0
+ Revision: 59842
- Add support for DRI on Intel i965

* Wed Aug 30 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5-12mdv2007.0
+ Revision: 58895
- enable tdfx for x86 and x86_64

* Thu Aug 24 2006 Olivier Blin <oblin@mandriva.com> 6.5-11mdv2007.0
+ Revision: 57986
- ensure all GART allocations are freed on context destruction (r300)
- rediff Patch44, and really apply it (GL may finally work on r300 PCIE)

* Fri Aug 18 2006 Olivier Blin <oblin@mandriva.com> 6.5-10mdv2007.0
+ Revision: 56829
- mesa-6.5-10mdv2007.0
- fix r300 on PCIE (glxinfo now works, but GL apps still make the X server crash)

* Fri Aug 11 2006 Olivier Blin <oblin@mandriva.com> 6.5-9mdv2007.0
+ Revision: 55526
- make sure mesa-source-file-generator is executable
- make sure mesa-driver-install can be executed
- bump release
- add missing glxext.c bits in old mesa-6.5-tfp-fbconfig-attribs.patch
- rename last mesa-6.5-texture-from-pixmap-fixes.patch bits as mesa-6.5-no-ARB_render_texture.patch
- move texture_from_pixmap tokens patch in mesa-6.5-texture_from_pixmap_tokens.patch
- move tfp_entrypoints patch in mesa-6.5-tfp_entrypoints.patch (and use upstream CVS diff)
- Add attrib_list to glXBindTexImageEXT
- remove attribList from glXBindTexImageEXT prototype, it breaks the extension because of incomplete implementation

* Thu Aug 03 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5-8mdv2007.0
+ Revision: 48074
- remove remaining menu references
- Removed old menu entries from mesa demos.
- disable some checks making Google Earth work on r300 cards (#23854)
- Fixed a typo in previous commit
- There is no i830
- Added provides for the old mesa glu and glut devel packages (#22551)
- Many fixes for linux-dri (thanks Christiaan Welvaart)
- Enable r300 installation
- Added a more recente texture-from-pixmap-fixes patch
- Added two more patches fixing the tfp extension
- rebuild to fix compilation on x86_64
- compile mesa xdemos (glxinfo and glxgears are back).
- put a brief comment for the patches
- Adding some patches (thanks S?\195?\131?\194?\169bastien savari):
  * Fix the texture from pixmap extension implementation
  * Enable r300 support (it is experimental yet)
  * static inline functions are broken on some architetures
  * no exec stack for ELF
  * in some cases radeon may have 0 bits depth
- Added initial EGL support to the package (I left it disabled for now as it
  seems some header files are still missing)
- new upstream release: 6.5
- added a patch fixing the path where dri modules are in.
- moved old changelog to ../misc
- fixed some dependencies
- adding an updated mesa prepared to be used by the X.org 7.0

  + Per Øyvind Karlsen <pkarlsen@mandriva.com>
    - include %%{_includedir}/GL/svgamesa.h on %%{sunsparc}
    - add list of dri drivers to build on sparc
      indent
      fix path to demos in menu item

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix build (parallel build is broken)
    - better description of GLw too
    - better description of GLU and GLUT

  + Christiaan Welvaart <cjw@daneel.dyndns.org>
    - fix build for ppc: do not build sis by using linux-dri-ppc make target
    - Fix build on ppc by adding svgamesa.h to filelist

  + Helio Chissini de Castro <helio@mandriva.com>
    - Added compile fix patch for x86_64 by Thierry Vignaud

  + Andreas Hasenack <andreas@mandriva.com>
    - renamed mdv to packages because mdv is too generic and it's hosting only packages anyway


* Tue Oct  4 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 5.0.2-12mdk
- merge ppc64 build fixes from older branch

* Tue Aug 16 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 5.0.2-11mdk
- adapt rpath patch for libtool 1.5.18

* Thu Aug  4 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 5.0.2-10mdk
- gcc4 fixes
- remove obsolete libGLU hack

* Thu Feb 10 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 5.0.2-9mdk
- libtool fixes

* Fri Sep 17 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 5.0.2-8mdk
- use libtool 1.4 for now

* Fri Aug 20 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 5.0.2-7mdk
- add BuildRequires: automake1.4
- remove packager tag

* Mon Aug 16 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 5.0.2-6mdk
- Rebuild with new menu

* Thu Jun 10 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 5.0.2-5mdk
- Rebuild
- Reapply patch1

* Thu Jun  3 2004  Laurent Montel <lmontel@mandrakesoft.com> 5.0.2-4mdk
- Rebuild again new gcc

* Thu Jun  3 2004  Laurent Montel <lmontel@mandrakesoft.com> 5.0.2-3mdk
- Fix build against gcc 3.4
- Add patch to nuke unpackaged files (patch from Gb)

* Mon Dec 08 2003 Per yvind Karlsen <peroyvind@linux-mandrake.com> 5.0.2-2mdk
- provide MesaGLU-devel (closes #6297)

* Fri Oct 10 2003 Franois Pons <fpons@mandrakesoft.com> 5.0.2-1mdk
- updated with glx-xf4 (Utah-GLX for XFree86 4.2 and above).
- updated with GLwrapper 0.2.0 which can choose differrent libGL.so
  according to server GLX vendor.
- 5.0.2.

* Thu Jul 10 2003 Laurent MONTEL <lmontel@mandrakesoft.com> 5.0.1-5mdk
- Rebuild

* Thu Jun 12 2003 Guillaume Cottenceau <gc@mandrakesoft.com> 5.0.1-4mdk
- rebuild for gcc-3.3

* Sat May 24 2003 Stefan van der Eijk <stefan@eijk.nu> 5.0.1-3mdk
- rebuild for new deps
- sort out BuildRequires (binutils and libstdc++-devel are redundant)

* Fri Apr  4 2003 Guillaume Cottenceau <gc@mandrakesoft.com> 5.0.1-2mdk
- hail fpons, file-4.01 was broken, gwegwe said that it had a bad
  behaviour, need to rebuild to have the libraries provides back
- fix fponsux in major version of Mesaglut

* Thu Apr 03 2003 Franois Pons <fpons@mandrakesoft.com> 5.0.1-1mdk
- 5.0.1.

* Thu Jan 09 2003 Franois Pons <fpons@mandrakesoft.com> 5.0-3mdk
- added patch from Franscisco Javier Felix.
- updated GLwrapper to prefer /usr/lib/libGL.so.1 (for NVidia GLX support)

* Tue Nov 19 2002 Franois Pons <fpons@mandrakesoft.com> 5.0-2mdk
- fixed Summary and Description (OpenGL 1.4).
- newer GLwrapper with cosmetic changes and patch6 inside it.

* Mon Nov 18 2002 Franois Pons <fpons@mandrakesoft.com> 5.0-1mdk
- 5.0 releasing OpenGL 1.4 interface.
- removed files installed but not packaged.
- added libstdc++-devel >= 3.2 for BuildRequires.

* Sun Aug  4 2002 Stefan van der Eijk <stefan@eijk.nu> 4.0.3-6mdk
- Removed unneeded BuildRequires

* Fri Jul 26 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.3-5mdk
- Automated rebuild with gcc3.2

* Thu Jul 25 2002 Franois Pons <fpons@mandrakesoft.com> 4.0.3-4mdk
- make sure NDEBUG is defined for GLU.

* Mon Jul 15 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.3-3mdk
- Rpmlint fixes: configure-without-libdir-spec
- Use system libtool.m4 when regenerating configure script. Then,
  apply Patch1 (remove-rpath) to generated configure script.
- Don't care about {html,ps,pdf} docs in glx subdir. Anyway, text doc
  is not even generated. Aka. Nuke useless BuildRequires: tetex-dvips,
  ghostscript.

* Mon Jul 01 2002 Franois Pons <fpons@mandrakesoft.com> 4.0.3-2mdk
- fixed so version to 1.3.403 instead of 1.3.402.

* Wed Jun 26 2002 Franois Pons <fpons@mandrakesoft.com> 4.0.3-1mdk
- removed patch12 (no more needed, GGI configuration file location).
- 4.0.3.

* Wed May 15 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.2-5mdk
- Update Patch5 to link with libgcc_s which contains _Unwind_GetIP

* Wed May  8 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.2-4mdk
- Use %%make
- Patch5: Mesa contains C++ code from libnurbs/internals. So, do link
  libGLU with libsupc++. This also kills the CCLD hack to build demos

* Mon May 06 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.2-3mdk
- Automated rebuild in gcc3.1 environment

* Tue Apr 30 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.2-2mdk
- Fix build with gcc-3.1. Define CCLD to the C++ linker when building
  the demos, since libGLU contains C++ code.

* Fri Apr 05 2002 Franois Pons <fpons@mandrakesoft.com> 4.0.2-1mdk
- 4.0.2.

* Thu Jan 31 2002 Franois Pons <fpons@mandrakesoft.com> 4.0.1-4mdk
- fixed build requires for autoconf2.5.
- added missing doc files.

* Wed Jan 30 2002 Franois Pons <fpons@mandrakesoft.com> 4.0.1-3mdk
- removed libGL.so.1.3 as GLwrapper use it thinking it is a good
  acceleration (whatever point the link).

* Wed Jan 23 2002 Franois Pons <fpons@mandrakesoft.com> 4.0.1-2mdk
- fixed GLwrapper to use the right libGL Mesa library.
- using .png icon files.
- added libGL.so.1.3.

* Tue Jan 22 2002 Franois Pons <fpons@mandrakesoft.com> 4.0.1-1mdk
- 4.0.1.

* Sat Jan 19 2002 Stefan van der Eijk <stefan@eijk.nu> 4.0-3mdk
- BuildRequires

* Thu Nov 08 2001 Franois Pons <fpons@mandrakesoft.com> 4.0-2mdk
- GL library is now 1.3 instead of 1.2 (thanks to Oden Eriksson).
- updated GLwrapper with 0.1.6.

* Wed Nov 07 2001 Franois Pons <fpons@mandrakesoft.com> 4.0-1mdk
- 4.0.

* Tue Oct 23 2001 Franois Pons <fpons@mandrakesoft.com> 3.5-2mdk
- fix libglut3.so.* still in libMesaGLU1.

* Wed Oct 17 2001 Franois Pons <fpons@mandrakesoft.com> 3.5-1mdk
- synced with hackMesa-3.5 rpm.
- remove old compability symlinks.
- try to fix libtool use.
- split package with better naming.
- updated GLwrapper with 0.1.5.
- disabled SSE (some apps gets SIGFPE on probe).
- 3.5.

* Mon Jul 23 2001 Stefan van der Eijk <stefan@eijk.nu> 3.4.2-2mdk
- BuildRequires:		tcl XFree86-devel

* Fri May 18 2001 Franois Pons <fpons@mandrakesoft.com> 3.4.2-1mdk
- updated to 3.4.2.

* Tue Mar 27 2001 Franois Pons <fpons@mandrakesoft.com> 3.4.1-4mdk
- Fixed patch to restore GLU 1.2.
- Fixed reference to obsolete y option of tar to j.

* Sun Mar 18 2001 David BAUDENS <baudens@mandrakesoft.com> 3.4.1-3mdk
- Build with gcc on PPC

* Thu Mar 15 2001 Francis Galiegue <fg@mandrakesoft.com> 3.4.1-2mdk
- Skip utah_glx for ia64

* Thu Feb 15 2001 Franois Pons <fpons@mandrakesoft.com> 3.4.1-1mdk
- 3.4.1 and remove GLUtesselator patch.

* Wed Jan 24 2001 Giuseppe Ghib <ghibo@mandrakesoft.com> 3.4-8mdk
- patched mach64dmainit.c from CVS. Now /tmp/glx* is
  safely cleaned for mach64 on X exits.

* Tue Jan 02 2001 Franois Pons <fpons@mandrakesoft.com> 3.4-7mdk
- updated GLwrapper with 0.1.4.

* Sat Dec 31 2000 Giuseppe Ghib <ghibo@mandrakesoft.com> 3.4-6mdk
- added patch for real optimization with RPM_OPT_FLAGS.
- added glXGetProcAddressARB workaround for playing with Tuxracer :-)
- added a soft link to fixed a name typo with common_x86asm.S names
  (for --enable-x86).

* Fri Dec 22 2000 Franois Pons <fpons@mandrakesoft.com> 3.4-5mdk
- updated glx with 20001222 cvs snapshot (s3savage modification).
- moved mesa.conf to /etc/X11 and make sure Mesa take care of it, ugly.

* Tue Dec 05 2000 Franois Pons <fpons@mandrakesoft.com> 3.4-4mdk
- updated glx with 20001205 cvs snapshot (s3savage modification).
- created patch for s3savage compilation (just change include dep).

* Sun Nov 26 2000 David BAUDENS <baudens@mandrakesoft.com> 3.4-3mdk
- Fix build on PPC (again): use egcs to don't have a wonderful "Internal
  compilator error" with gcc-2.96

* Tue Nov 07 2000 Franois Pons <fpons@mandrakesoft.com> 3.4-2mdk
- fixed missing requires on Mesa-common for Mesa-common-devel.
- fixed Copyright (LGPL => MIT).
- updated glx with 20001107 cvs snapshot (version 0.10).
- build with glibc 2.1.97.

* Mon Nov 06 2000 Franois Pons <fpons@mandrakesoft.com> 3.4-1mdk
- 3.4.

* Thu Oct 19 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-16mdk
- updated glx to 20001017.
- build release for glibc-2.1.95.

* Mon Oct 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.3-15mdk
- Fix gcc2.96 compilation.

* Fri Sep 29 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-14mdk
- fixed menu entrie for morph.

* Tue Sep 26 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-13mdk
- update glx to 20000926 as a lot of change on S3Savage driver has occurs and
  this driver is marked as experimental (at least get latest version as there
  are no more change for some days).

* Sat Sep 09 2000 David BAUDENS <baudens@mandrakesoft.com> 3.3-12mdk
- Fix build for PPC (i.e. remove Patch #1, it's included in sources now)

* Sun Sep 03 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-11mdk
- added libMesaGL.so.3 symlink.
- added missing icons.
- moved menu file inside spec file.

* Mon Aug 28 2000 David BAUDENS <baudens@mandrakesoft.com> 3.3-10mdk
- Fix menu entries

* Fri Aug 25 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-9mdk
- really change to glx 20000825, removed obsolete gart_ver.
- rebuild glx-rename patch for new glx.

* Fri Aug 25 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-8mdk
- updated to GLwrapper 0.1.3 to select support of Mesa extension,
  enable OSMesa and disable XMesa (it breaks hardware acceleration of DRI).
- updated glx to 20000825.
- changed symlink libMesaGL* to true Mesa libraries (avoid wrapper).
- enabled previously disabled agp support for glx.

* Fri Aug 18 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-7mdk
- updated GLwrapper to 0.1.2, added some missing X Mesa functions.
- removed Mesa-devel as now provided by XFree86-devel.
- removed SVGA support, as Mesa-devel has gone.

* Thu Aug 03 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-6mdk
- created patch to restore GLUtesselator as needed by some program.
- updated libGLU version to 1.2.
- added GLwrapper README in doc.

* Mon Jul 31 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-5mdk
- added /usr/include/GL into Mesa-devel.
- added missing glext.h into %{prefix}/include/GL.
- some macroszifications.

* Thu Jul 27 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-4mdk
- updated GLwrapper to 0.1.1.
- now work with DRI in accelerated.
- removed glide support as it is enabled in XFree 4.0.1.

* Wed Jul 26 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-3mdk
- created GLwrapper to get a true GL API.
- removed conflict with XFree86 version greater than 4.

* Mon Jul 24 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-2mdk
- created patch to rename glx.so to glx-3.so as warnings are dumped else.

* Mon Jul 24 2000 Franois Pons <fpons@mandrakesoft.com> 3.3-1mdk
- 3.3.
- update glx to CVS version of 2000/07/24.
- moved module glx.so to glx-3.so.
- using Mesa-3.2.1 for glx.

* Thu Jun 28 2000 Giuseppe Ghib <ghibo@mandrakesoft.com> 3.2-4mdk
- added conflicts with XFree86 >= 4.0.

* Sat Jun 17 2000 Giuseppe Ghib <ghibo@mandrakesoft.com> 3.2-3mdk
- disabled ggi in ./configure.
- added option to compile with Voodoo glide support.

* Tue Jun 13 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.2-2mdk
- fix: remove need on libggi and libgii

* Sat Jun 10 2000 Giuseppe Ghib <ghibo@mandrakesoft.com> 3.2-1mdk
- updated to version 3.2.
- glx updated to version 2000611.
- disabled MTRR for i386/i486.
- moved glx script to /usr/bin.
- added --disable-glut and --disable-GLU in glx building as the
  respective libraries are already built in the main Mesa tree.

* Tue May 16 2000 Frederic Lepied <flepied@mandrakesoft.com> 3.1-16mdk
- fix fix for i486 to allow compilation on other archs !

* Sun May 14 2000 David BAUDENS <baudens@mandrakesoft.com> 3.1-15mdk
- Fix build for i486
- Clean after build
- Fix some typos

* Sun May  7 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1-14mdk
- added more compatibility links to Mesa for Fermigier

* Fri Apr 28 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1-13mdk
- really fixed hardcoded path

* Fri Apr 28 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1-12mdk
- added 32x32 icons, fixed hardcoded path in menu entries

* Mon Apr 17 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1-11mdk
- added symlinks to libMesaGL and libMesaGLU for compatibility
  with older applications

* Wed Apr 12 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1-10mdk
- fixed group for Mesa-demos
- added menu entries for best demos
- fixed ftp, added url
- added documentation
- patched ltconfig to remove binary-or-shlib-defines-rpath

* Mon Apr  3 2000 Frederic Lepied <flepied@mandrakesoft.com> 3.1-9mdk
- split glut and GLU in common and common-devel packages to ease
  the upgrade to XFree86 4.0.

* Sun Mar 19 2000 John Buswell <johnb@mandrakesoft.com> 3.1-8mdk
- Added patch for PPC arch
- Included PPC in GLX skip
- Added ifarch 

* Fri Jan 28 2000 Francis Galiegue <francis@mandrakesoft.com>
- Added .so symlinks in -devel

* Mon Jan 17 2000 Francis Galiegue <francis@mandrakesoft.com>
- Made demos fully functional

* Mon Jan 17 2000 Francis Galiegue <francis@mandrakesoft.com>
- Also skip svgalib for sparcs

* Thu Jan 13 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1-4mdk
- Make sure to get the right link.

* Tue Jan 11 2000 Pixel <pixel@mandrakesoft.com>
- fix build for non-svgalib architectures

* Mon Dec 20 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- id k6 chipset as i586 for glx

* Tue Dec 14 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Mesa 3.1 final.
- rewrite files

* Sat Dec 11 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
-  Really fix alpha build (no glx for you)
- and use _tmppath in Buildroot

* Tue Dec 07 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Fix alpha build (i think)
- Clean up .spec (scared chmou, big wuss) ;)
- make cheesie 'glx' script to LD_PRELOAD the libGL.so.1.0 for the demos

* Fri Nov 26 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Update cvs snaps
- Use new --with-chipset=both for glx
- (this is not backwards compatible, you must recompile) don't blame me ask the Mesa people
- use the right --target (must say they did a damned fine job of optimizing the code

* Tue Nov 02 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- add arch's, defattr
- integrate glx (mga_gxl.so, tnt_glx.so)

* Mon Oct 11 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Back to old Mesa lib.

* Fri Jul 16 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.de>
- remove the -ffast-math removal stuff - Mesa 3.1 works with -ffast-math
  and is actually 11.7% faster than without it.

* Fri Jul 16 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.de>
- 3.1beta2

* Wed Jun 30 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Build in the new environement (rel: 3mdk).

* Thu May 06 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- ldconfig to %post and %postun.

* Mon Feb 15 1999 Bernhard Rosenkraenzer <bero@microsoft.sucks.eu.org>
- initial RPM; changes to base:
- Handle RPM_OPT_FLAGS
- link with pthread library
